SLASH_HELMHIDE1 = "/helmhide"
SLASH_HELMHIDE2 = "/hh"

function SlashCmdList.HELMHIDE(msg, editbox)
	if msg == "on" then
		helmHideEnabled = true
		print("Helm Hide Enabled")
	elseif msg == "off" then
		helmHideEnabled = false
		print("Helm Hide Disabled")
	end
end

function helmHideFrameOnEvent(self, event, message)
	if helmHideEnabled then
		if IsResting() then
			HelmHideHelmHide()
			HelmHideCloakHide()
		else
			HelmHideHelmShow()
			HelmHideCloakShow()
		end
	end
end

function HelmHideHelmHide()
	PickupInventoryItem(GetInventorySlotInfo("HeadSlot"))
	local helmHideType, helmHideId = GetCursorInfo()
	if helmHideId ~= nil then
		helmHideHelm = GetItemInfo(helmHideId)
		PutItemInBag(ContainerIDToInventoryID(4))
	end
end

function HelmHideHelmShow()
	for i = 1, GetContainerNumSlots(4) do
		local helmHideId = GetContainerItemID(4, i)
		if helmHideId ~= nil then
			local helmHideName = GetItemInfo(helmHideId)
			if helmHideName == helmHideHelm then
				PickupContainerItem(4, i)
				PickupInventoryItem(GetInventorySlotInfo("HeadSlot"))
			end
		end
	end
end

function HelmHideHelmToggle()
	PickupInventoryItem(GetInventorySlotInfo("HeadSlot"))
	local helmHideType, helmHideId = GetCursorInfo()
	if helmHideId ~= nil then
		HelmHideHelmHide()
		HelmHideHelmHide()
	else
		HelmHideHelmShow()
	end
end

function HelmHideCloakHide()
	PickupInventoryItem(GetInventorySlotInfo("BackSlot"))
	local helmHideType, helmHideId = GetCursorInfo()
	if helmHideId ~= nil then
		helmHideCloak = GetItemInfo(helmHideId)
		PutItemInBag(ContainerIDToInventoryID(4))
	end
end

function HelmHideCloakShow()
	for i = 1, GetContainerNumSlots(4) do
		local helmHideId = GetContainerItemID(4, i)
		if helmHideId ~= nil then
			local helmHideName = GetItemInfo(helmHideId)
			if helmHideName == helmHideCloak then
				PickupContainerItem(4, i)
				PickupInventoryItem(GetInventorySlotInfo("BackSlot"))
			end
		end
	end
end

function HelmHideCloakToggle()
	PickupInventoryItem(GetInventorySlotInfo("BackSlot"))
	local helmHideType, helmHideId = GetCursorInfo()
	if helmHideId ~= nil then
		HelmHideCloakHide()
		HelmHideCloakHide()
	else
		HelmHideCloakShow()
	end
end

function HelmHideCreateButton(icon_on, help, toggle, ...)
	local button = CreateFrame("BUTTON", nil, CharacterModelFrame)
	
	-- setup
	local hilite = button:CreateTexture(nil, "HIGHLIGHT")
	hilite:SetAllPoints()
	hilite:SetTexture("Interface\\Common\\UI-ModelControlPanel")
	hilite:SetTexCoord(0.57812500, 0.82812500, 0.00781250, 0.13281250)
	
	button:SetWidth(32)
	button:SetHeight(32)
	button:SetPoint(...)
	button:Hide()
	button:SetNormalTexture(icon_on)

	button:RegisterEvent("PLAYER_FLAGS_CHANGED")
	button:RegisterEvent("PLAYER_ENTERING_WORLD")
	button:SetScript("OnEvent", update)

	-- click
	button:SetScript("OnClick", function()
		toggle()
	end)

	-- hover
	button:SetScript("OnEnter", function()
		button:SetAlpha(1)
		GameTooltip:SetOwner(button, "ANCHOR_TOPRIGHT")
		GameTooltip:SetText(help, nil, nil, nil, nil, 1)
	end)
	button:SetScript("OnLeave", function()
		button:SetAlpha(0.5)
		GameTooltip_Hide()
	end)
	button:SetAlpha(0.5)

	CharacterModelFrame:HookScript("OnEnter", function()
		button:Show()
	end)
	CharacterModelFrame:HookScript("OnLeave", function(self)
		if not self:IsMouseOver() then
			button:Hide()
		else
			-- XXX fix control buttons
			self.controlFrame:Show()
		end
	end)
end

local helmHideFrame = CreateFrame("FRAME", nil, UIParent)
helmHideFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
helmHideFrame:RegisterEvent("PLAYER_UPDATE_RESTING");
helmHideFrame:RegisterEvent("ZONE_CHANGED");
helmHideFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
helmHideFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
helmHideFrame:RegisterEvent("PLAYER_LOGIN");
helmHideFrame:SetScript("OnEvent", helmHideFrameOnEvent)

HelmHideCreateButton(
	"Interface\\AddOns\\HelmHide\\HelmShow",
	SHOW_HELM,
	HelmHideHelmToggle,
	"BOTTOMLEFT", 5, 5
)

HelmHideCreateButton(
	"Interface\\AddOns\\HelmHide\\CloakShow",
	SHOW_CLOAK,
	HelmHideCloakToggle,
	"BOTTOMRIGHT", -5, 5
)